PROGRAM interoptesting
    USE, intrinsic :: iso_c_binding

    INTERFACE
        !! C prototype: double calledbyfortran(int i, double *x)
        FUNCTION calledbyfortran(i, x) BIND(C)
            USE, intrinsic :: iso_c_binding
            real(kind=c_double) :: calledbyfortran
            integer(kind=c_int), value :: i
            real(kind=c_double), intent(inout) :: x 
        END FUNCTION calledbyfortran
    END INTERFACE 

    integer :: i
    double precision :: x
    
    i = 15
    x = 2.d0
    call callsc(i, x)

    CONTAINS
        SUBROUTINE callsc(i, x)
            integer, intent(in) :: i
            double precision, intent(inout) :: x
            double precision :: prod

            print *, '(1) In the FORTRAN routine before call to C'
            print *, '(1) i = ', i, ' x = ', x
            prod = calledbyfortran(i,x)
            print *, '(1) In the FORTRAN routine after call to C'
            print *, '(1) i = ', i, ' x = ', x, ' prod = ', prod
        END SUBROUTINE callsc
END program
