program interface
    use integrate
    use functions
    implicit none

    real, parameter :: pi = 4.*atan(1.)
    real :: approx
    real :: exact = pi

    print *, 'Integrating using default tol'
    approx = integratefx(0., 2*pi, sinesquared)
    print *, 'Approximate integral = ', approx
    print *, 'Exact integral = ', exact

    print *, ''
    print *, 'Integrating using coarser tol'
    approx = integratefx(0., 2*pi, sinesquared, 0.01)
    print *, 'Approximate integral = ', approx

    print *, ''
    print *, 'Integrating using still coarser tol'
    approx = integratefx(xhi=2*pi, xlo=0., tol=0.5, &
                         f=sinesquared)
    print *, 'Approximate integral = ', approx
end program interface
